CPU,TPOOL_NTHREADS=4

;dir_name=2013_05_20_00
;current_time=2013052012
;   stop_time=2013052023

;current_time=2013052100
;   stop_time=2013052111

; set the format for current time to be read in
current_time=2013012012
dir_name='2013_01_20_00'

;print,current_time,stop_time

openr,3,'true_color.fil'
nfiles=0l
readf,3,nfiles
readf,3,dir_name

;readf,3,current_time
;syear=strmid(current_time,0,6)
;syear=strtrim(syear,2)
;smonth=strmid(current_time,6,2)
;sday=strmid(current_time,8,2)
;shour=strmid(current_time,10,2)



for nf=0,nfiles-1 do begin

readf,3,current_time
print,'current ',current_time
year=strmid(current_time,0,6)
year=strtrim(year,2)
month=strmid(current_time,6,2)
day=strmid(current_time,8,2)
hour=strmid(current_time,10,2)

print,year,' ',month,' ',day,' ',hour
;
; CRTM reflectance output
;
;datdir='/cimss/REALTIME_PROXY/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+year+'_'+month+'_'+day+'_00/'
;datdir='/cimss/MOORE/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+year+'_'+month+'_'+day+'_00/'
;datdir='/cimss/MOORE/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+syear+'_'+smonth+'_'+sday+'_'+shour+'/'
;datdir='/cimss/REALTIME_PROXY/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+syear+'_'+smonth+'_'+sday+'_'+shour+'/'
datdir='/cimss/REALTIME_PROXY/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+dir_name+'/'
datfil='TOArads_abi_crtmvis_no_ray_'+year+'.'+month+'.'+day+'.'+hour+'0000_CRTM_V2.1_realtime.cimss.reflectivity.nc'

file01=datdir+datfil
print,' READING CRTM FILE = ', file01

nc_file_id=ncdf_open(file01,/nowrite)

glob_info=ncdf_inquire(nc_file_id)

; get dimensions
    for idim=0,glob_info.ndims-1 do begin
     ncdf_diminq,nc_file_id, idim, name, dim
     if name eq 'west_east' then nc=dim
     if name eq 'south_north' then nr=dim
    endfor
;
natt=glob_info.ngatts
   for n=0,natt-1 do begin
    name = NCDF_ATTNAME(nc_file_id, /GLOBAL, n) ;Get the second attribute's name.
    NCDF_ATTGET, nc_file_id, /GLOBAL, name, attvalue ;Retrieve the date.
    result = NCDF_ATTINQ(nc_file_id, /GLOBAL, name) ;Get info about the attribute.
   endfor
   for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
   endfor
;

   ncdf_varget, nc_file_id, 'lat', lat
   ncdf_varget, nc_file_id, 'lon', lon
   ncdf_varget, nc_file_id, 'solarzen', solarzen
   ncdf_varget,nc_file_id,'ABI_refl_b01',blue1
   ncdf_varget,nc_file_id,'ABI_refl_b02',red1
;
   ncdf_close,nc_file_id

print,'lat ',max(lat),min(lat)
print,'lon ',max(lon),min(lon)

; multiply by cos(zenith angle) to get reflectance factor
dtor=!pi/180.
;blue1=float(blue1)
;red1=float(red1)
blue1=float(blue1)*cos(solarzen*dtor)
red1=float(red1)*cos(solarzen*dtor)
print,'blue ',max(blue1),min(blue1)
print,'red ',max(red1),min(red1)

;MODIS band 4 (green)

datfil='TOArads_abi_crtmvis_modis_band4'+year+'.'+month+'.'+day+'.'+hour+'0000_CRTM_V2.1_realtime.cimss.reflectivity.nc'
file01=datdir+datfil
print,' READING CRTM FILE = ', file01

nc_file_id=ncdf_open(file01,/nowrite)
glob_info=ncdf_inquire(nc_file_id)
; get dimensions
    for idim=0,glob_info.ndims-1 do begin
     ncdf_diminq,nc_file_id, idim, name, dim
     if name eq 'west_east' then nc=dim
     if name eq 'south_north' then nr=dim
    endfor
;
natt=glob_info.ngatts
   for n=0,natt-1 do begin
    name = NCDF_ATTNAME(nc_file_id, /GLOBAL, n) ;Get the second attribute's name.
    NCDF_ATTGET, nc_file_id, /GLOBAL, name, attvalue ;Retrieve the date.
    result = NCDF_ATTINQ(nc_file_id, /GLOBAL, name) ;Get info about the attribute.
   endfor
   for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
   endfor
;
   ncdf_varget, nc_file_id, 'lat', lat
   ncdf_varget, nc_file_id, 'lon', lon
   ncdf_varget,nc_file_id,'MODIS_refl_b04',green1
   ncdf_close,nc_file_id

;green1=float(green1)
green1=float(green1)*cos(solarzen*dtor)

print,max(blue1),max(red1),max(green1)

red11=-999.+0.*fltarr(nc,nr)
green11=-999.+0.*fltarr(nc,nr)
blue11=-999.+0.*fltarr(nc,nr)

index10101=where(red1 gt 1000)
index10102=where(blue1 gt 1000)
index10103=where(green1 gt 1000)

;index10101=where(red1 ge 0.)
;index10102=where(blue1 ge 0.)
;index10103=where(green1 gt 0.)

if index10103 ge 0 then begin
green1(index10103)=1000.
blue1(index10102)=1000.
red1(index10101)=1000.
endif

index305=where(red1 ge 0.)
index306=where(blue1 ge 0.)
index307=where(green1 ge 0.)

index305=where(red1 ge 0. and blue1 ge 0 and green1 ge 0.)

red11(index305)=(red1(index305))
green11(index305)=(green1(index305))
blue11(index305)=(blue1(index305))

red=red11
grn=green11
blu=blue11

; tks, following paper of miller et al. 2012 set min to 0.0223
;set cutoof to 0.0223 to follow miller et al.
; here using scaling from ATBD, see below

;cutoff=0.0223
cutoff=0.0
;val=0.
 val=cutoff
index=where(red lt cutoff)
;if index(0) ne -1 then red(index)=cutoff
if index(0) ne -1 then red(index)=val

index=where(grn lt cutoff)
;if index(0) ne -1 then grn(index)=cutoff
if index(0) ne -1 then grn(index)=val

index=where(blu lt cutoff)
;if index(0) ne -1 then blu(index)=cutoff
if index(0) ne -1 then blu(index)=val

; tks

print,'red ',max(red),min(red)
print,'blue ',max(blu),min(blu)
print,'green ',max(grn),min(grn)

index=where(red lt 0.)
if index(0) ne -1 then red(index)=0.
index=where(grn lt 0.)
if index(0) ne -1 then grn(index)=0.
index=where(blu lt 0.)
if index(0) ne -1 then blu(index)=0.

index=where(red gt 255.)
if index(0) ne -1 then red(index)=255.
index=where(grn gt 255.)
if index(0) ne -1 then grn(index)=255.
index=where(blu gt 255.)
if index(0) ne -1 then blu(index)=255.
;
print,' BEFORE SQRT ENHACEMENT' 
print,'red ',max(red),min(red)
print,'green ',max(grn),min(grn)
print,'blue ',max(blu),min(blu)
help, red,grn,blu
;
; SQRT enhancement
;
red=(ROUND(SQRT(red*100.)*25.5))/255.
grn=(ROUND(SQRT(grn*100.)*25.5))/255.
blu=(ROUND(SQRT(blu*100.)*25.5))/255.

print,' AFTER SQRT ENHACEMENT'
print,'red ',max(red),min(red)
print,'green ',max(grn),min(grn)
print,'blue ',max(blu),min(blu)

;scaling from ATBD

red=bytscl(red,min=-0.0409,max=1.2669)
grn=bytscl(grn,min=-0.0397,max=1.2304)
blu=bytscl(blu,min=-0.0390,max=1.2089)
;uncomment these lines if using Miller et al. scaling
;red=255B*(red)
;grn=255B*(grn)
;blu=255B*(blu)




print,' AFTER ADJ SCALING'
print,'red ',max(red),min(red)
print,'green ',max(grn),min(grn)
print,'blue ',max(blu),min(blu)

index=where(red gt 255.)
if index(0) ne -1 then red(index)=255.
index=where(grn gt 255.)
if index(0) ne -1 then grn(index)=255.
index=where(blu gt 255.)
if index(0) ne -1 then blu(index)=255.

print,' AFTER set back'
print,'red ',max(red),min(red)
print,'green ',max(grn),min(grn)
print,'blue ',max(blu),min(blu)


if max(red) eq min(red) and max(grn) eq min(grn) and max(blu) eq min(blu) then begin
red=0.0*red
blu=blu*0.0
grn=grn*0.0
endif

nxpix=1200L
nypix=720L
SETPLOT='ps'
nxdim=long(1200.*1200./864.)
nydim=long(720.*720./518.)
if setplot eq 'ps' then begin
   lc=0
   set_plot,'ps'
   xsize=nxdim/100.
   ysize=nydim/100.
   device,/symbol,font_index=4
   device,/portrait,bits=8,$
   filename='RAW_TC_RGB_'+year+'_'+month+'_'+day+'_'+hour+'z.wrfchem.ps'
   device,/color
   device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
          xsize=xsize,ysize=ysize
   !p.font=0
endif
loadct,0
erase
; device,decomposed=0

;  set_viewport,.02,.98,.01,.99
set_viewport,0,1,0,1

    MAP_SET,0,0,0,limit=[18,-133,51.5,-63],/contin,/USA   ;Marek set this slightly differenct to have it plot better
;

red_patch=map_patch(red,lon,lat)
grn_patch=map_patch(grn,lon,lat)
blu_patch=map_patch(blu,lon,lat)

result=size(red_patch,/dimensions)
nc=result(0)
nr=result(1)

true=bytarr(3,nc,nr)
true(0,*,*)=red_patch
true(1,*,*)=grn_patch
true(2,*,*)=blu_patch

TVSCL,true,true=1
MAP_SET,0,0,0,limit=[18,-132.5,51.5,-63.5],/noerase,color=255,/contin,/USA
loadct,39

xyouts,[.01],[.05],['!17SSEC/CIMSS'],charsize=1.4,/normal,color=120
xyouts,[.01],[.02],['!17CRTM - Blue, red from ABI, Green from MODIS'],charsize=1.4,/normal,color=120
xyouts,[.38],[.02],['ABI TrueColor RGB '+year+'_'+month+'_'+day+'_'+hour+':00 UTC'],charsize=1.4,/normal,color=120
xyouts,[.01],[.12],['!17RAYLEIGH Scattering Correction'],charsize=1.2,/normal,color=120
xyouts,[.01],[.17],['!17SQRT Enhancement'],charsize=1.2,/normal,color=120
device,/close

current_time=current_time +1

endfor
;
end
