#!/bin/bash


scripts='/home/kbah/code/idl/rgb/sh_files'


#make date directory for multi-band-files

#in_dir=${in_path}${datedir}
out_dir=$scripts/fil_files

if [ ! -d ${out_dir} ]; then
 mkdir ${out_dir}
fi


cd ${out_dir}

temp="$(ls *.fil 2>/dev/null)" 
echo "temp= $temp"

if [ ! -z "$temp" ]; then
  rm *.fil
fi
## ls -l *.fil

cd ${scripts}

ayear='2014'

for i in $(echo 1 2 3 4 5 6 7 8 9 10 11 12)    #month
do 
	amonth='_0'${i}
	
	if [ ${i} -ge 10 ]
	then
		amonth='_'${i}	
	fi
	
	for j in $(echo 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31)   # Date
	do 
		aday='_0'${j}
		if [ ${j} -ge 10 ]
		then
			aday='_'${j}	
		fi
		adate=$ayear$amonth$aday'_00'
		echo 'date='${adate}
		
		for k in  $(echo 12 13 14 15 16 17 18 19 20 21 22 23)    #$(echo 1 2 3 4 5 6 7 8 9 10 11 )     #Time 
		do
			tt='0'${k}   #tt='_0'${k}
			if [ ${k} -ge 10 ]
			then
				tt=${k}	
			fi
			atime=${tt}'0000'	
			echo 'atime='${atime}
			
			# Create a .fil file to be passed in the IDL sub-routine for multibanded files generations.
			fil_file=${out_dir}/${adate}${atime}_GESNDR.fil
			echo ${adate} >$fil_file
			echo ${atime} >>$fil_file
		done 
	done
done

# Create a .fil file to be passed in the IDL sub-routine for multibanded files generations.
#fil_file=${out_dir}/fil_files/${adate}${atime}_GESNDR.fil
#echo ${adate} >$fil_file
#echo ${atime} >$fil_file

#ls ${in_dir}/GESNDR_band01*.nc | wc -l >$fil_file
#ls -1 ${in_dir}/GESNDR_band01*.nc | cut -c78-94>>$fil_file

#/usr/local/bin/idl < $scripts/call_idl_sub_routines.sh

exit 0
















