CPU,TPOOL_NTHREADS=4
;pro ABIS_IR_display_png
t1=systime(/UTC)
tt1=strcompress(t1,/remove_all)
if strlen(tt1) eq 20 then begin
year=strcompress(strmid(tt1,16,4),/remove_all)
monstr=strcompress(strmid(tt1,3,3),/remove_all)
hrstr=strcompress(strmid(tt1,8,2),/remove_all)
day=strcompress(strmid(tt1,6,2),/remove_all)
endif
if strlen(tt1) eq 19 then begin
year=strcompress(strmid(tt1,15,4),/remove_all)
monstr=strcompress(strmid(tt1,3,3),/remove_all)
hrstr=strcompress(strmid(tt1,7,2),/remove_all)
day=strcompress(strmid(tt1,6,1),/remove_all)
endif

if fix(day) lt 10 then day=strcompress('0'+string(day),/remove_all)
; check for leapyear
leapyear=(399+(fix(year) mod 400))/400-(3+(fix(year) mod 4))/4
;


case monstr of
 'Jan':month='01'
 'Feb':month='02'
 'Mar':month='03'
 'Apr':month='04'
 'May':month='05'
 'Jun':month='06'
 'Jul':month='07'
 'Aug':month='08'
 'Sep':month='09'
 'Oct':month='10'
 'Nov':month='11'
 'Dec':month='12'
endcase
;
; Previous month and day
;
logicday=fix(day)
if logicday ge 2. then begin
  previousday=logicday-1& previousmonth=month
  if previousday lt 10 then previousday=strcompress('0'+string(previousday),/remove_all)
  if previousday ge 10 then previousday=strcompress(string(previousday),/remove_all)
endif
;
if logicday lt 2. then begin
 if month eq '01' then previousday='31'
 if month eq '01' then previousmonth='12'
 if month eq '02' then previousday='31'
 if month eq '02' then previousmonth='01'
 if month eq '03' then begin
  if leapyear eq 1 then previousday='29'& previousmonth='02'
  if leapyear eq 0 then previousday='28'& previousmonth='02'
 endif
 if month eq '04' then previousday='31'& previousmonth='03'
 if month eq '05' then previousday='30'& previousmonth='04'
 if month eq '06' then previousday='31'& previousmonth='05'
 if month eq '07' then previousday='30'& previousmonth='06'
 if month eq '08' then previousday='31'& previousmonth='07'
 if month eq '09' then previousday='31'& previousmonth='08'
 if month eq '10' then previousday='30'& previousmonth='09'
 if month eq '11' then previousday='31'& previousmonth='10'
 if month eq '12' then previousday='30'& previousmonth='11'
endif
;
previousyear=year
if month eq '01' and day eq '01' then previousyear=strcompress(string(fix(year)-1),/remove_all)

;
; NEXT DAY LOGIC
;
nextday=strcompress(string(fix(day)+1),/remove_all)
if fix(nextday) lt 10 then nextday='0'+nextday
datday=day
nextyear=year
nextmonth=month
if month eq '01' and day eq '31' then nextmonth='02'
if month eq '01' and day eq '31' then nextday='01'

if month eq '02' and day eq '29' and leapyear eq 1 then nextmonth='03'
if month eq '02' and day eq '29' and leapyear eq 1 then nextday='01'

if month eq '02' and day eq '28' and leapyear eq 0 then nextmonth='03'
if month eq '02' and day eq '28' and leapyear eq 0 then nextday='01'

if month eq '03' and day eq '31' then nextmonth='04'
if month eq '03' and day eq '31' then nextday='01'

if month eq '04' and day eq '30' then nextmonth='05'
if month eq '04' and day eq '30' then nextday='01'

if month eq '05' and day eq '31' then nextmonth='06'
if month eq '05' and day eq '31' then nextday='01'

if month eq '06' and day eq '30' then nextmonth='07'
if month eq '06' and day eq '30' then nextday='01'

if month eq '07' and day eq '31' then nextmonth='08'
if month eq '07' and day eq '31' then nextday='01'

if month eq '08' and day eq '31' then nextmonth='09'
if month eq '08' and day eq '31' then nextday='01'

if month eq '09' and day eq '30' then nextmonth='10'
if month eq '09' and day eq '30' then nextday='01'

if month eq '10' and day eq '31' then nextmonth='11'
if month eq '10' and day eq '31' then nextday='01'

if month eq '11' and day eq '30' then nextmonth='12'
if month eq '11' and day eq '30' then nextday='01'

if month eq '12' and day eq '31' then nextmonth='01'
if month eq '12' and day eq '31' then nextday='01'
if month eq '12' and day eq '31' then nextyear=strcompress(string(fix(year)+1),/remove_all)


for kk=0,23 do begin

;datdir='/cimss/REALTIME_PROXY/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+year+'_'+month+'_'+datday+'_00/'
datdir='/cimss/SCHAACK/REALTIME_PROXY_ALL_BADGER_EAST/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'+year+'_'+month+'_'+datday+'_00/'
if kk le 11 then begin
dathour=strcompress(string(12+kk),/remove_all)
endif
if kk gt 11 then begin
dathour=strcompress(string(kk-12),/remove_all)
day=nextday
if fix(dathour) lt 10 then dathour='0'+dathour
endif

if kk le 11 then datfil='TOArads_abi_conus_east_crtmir_'+year+'.'+month+'.'+day+'.'+dathour+'0000_CRTM_V2.1_realtime.cimss.emissivity.nc'
if kk gt 11 then datfil='TOArads_abi_conus_east_crtmir_'+nextyear+'.'+nextmonth+'.'+nextday+'.'+dathour+'0000_CRTM_V2.1_realtime.cimss.emissivity.nc'

;if kk lt 10 then hr=strcompress('0'+string(kk),/remove_all)
;if kk ge 10 then hr=strcompress(string(kk),/remove_all)

;if kk le 11 then datdir='/cimss/REALTIME_PROXY/CRTMOUT/Netcdf/Without_Time/Realtime/'+previousyear+'_'+previousmonth+'_'+previousday+'_00/'
;if kk gt 11 then datdir='/cimss/REALTIME_PROXY/CRTMOUT/Netcdf/Without_Time/Realtime/'+year+'_'+month+'_'+day+'_00/'
;
;datfil='TOArads_abi_crtmir_'+year+'.'+month+'.'+day+'.'+hr+'0000_CRTM_V2.04_realtime.default.emissivity.nc'
file01=datdir+datfil
print, 'file opened => ', file01
;
hour=strcompress(strmid(datfil,41,2),/remove_all)
if kk le 11 then date=year+'-'+month+'-'+day
if kk gt 11 then date=nextyear+'-'+nextmonth+'-'+nextday

;
;status=findfile(file01, count=found_file)
 if findfile(file01) ne file01 then print, file01+' not found, skipping'
 if findfile(file01) ne file01 then goto, jump
; if findfile(file01) ne 0 then continue
;    print,' READING CRTM FILE = ', datfil
;
    nc_file_id=ncdf_open(datdir+datfil,/nowrite)
;
    glob_info=ncdf_inquire(nc_file_id)
;
; get dimensions
    for idim=0,glob_info.ndims-1 do begin
     ncdf_diminq,nc_file_id, idim, name, dim
     if name eq 'west_east' then nc=dim
     if name eq 'south_north' then nr=dim
    endfor
;
natt=glob_info.ngatts
   for n=0,natt-1 do begin
    name = NCDF_ATTNAME(nc_file_id, /GLOBAL, n) ;Get the second attribute's name.
    NCDF_ATTGET, nc_file_id, /GLOBAL, name, attvalue ;Retrieve the date.
    result = NCDF_ATTINQ(nc_file_id, /GLOBAL, name) ;Get info about the attribute.
   endfor
   for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
   endfor
;
   ncdf_varget, nc_file_id, 'lat', lat
   ncdf_varget, nc_file_id, 'lon', lon
;   ncdf_varget,nc_file_id,'altitude',alt
   ncdf_varget,nc_file_id,'ABI_tb_b07',tb07
   ncdf_varget,nc_file_id,'ABI_tb_b08',tb08
   ncdf_varget,nc_file_id,'ABI_tb_b09',tb09
   ncdf_varget,nc_file_id,'ABI_tb_b10',tb10
   ncdf_varget,nc_file_id,'ABI_tb_b11',tb11
   ncdf_varget,nc_file_id,'ABI_tb_b12',tb12
   ncdf_varget,nc_file_id,'ABI_tb_b13',tb13
   ncdf_varget,nc_file_id,'ABI_tb_b14',tb14
   ncdf_varget,nc_file_id,'ABI_tb_b15',tb15
   ncdf_varget,nc_file_id,'ABI_tb_b16',tb16
;
; close netCDF file
;
   ncdf_close,nc_file_id
;
;

for ii=0,9 do begin 

case ii of 
 0:dvar=tb07
 1:dvar=tb08
 2:dvar=tb09
 3:dvar=tb10
 4:dvar=tb11
 5:dvar=tb12
 6:dvar=tb13
 7:dvar=tb14
 8:dvar=tb15
 9:dvar=tb16
endcase

case ii of
 0:pvar='tb07'
 1:pvar='tb08'
 2:pvar='tb09'
 3:pvar='tb10'
 4:pvar='tb11'
 5:pvar='tb12'
 6:pvar='tb13'
 7:pvar='tb14'
 8:pvar='tb15'
 9:pvar='tb16'
endcase

band=strcompress(strmid(pvar,2,2),/remove_all)

;
; SCALING FROM GRYSCL.M MATLAB FUNCTION
;
con1=418.
con2=660.
tlim=242.

iiv=n_elements(dvar(*,1))
jjv=n_elements(dvar(1,*))

britarray=fltarr(iiv,jjv)
temp=fltarr(iiv,jjv)

tsmall=where(dvar lt tlim)
tbig=where(dvar ge tlim)

britarray(tsmall)=(con1-dvar(tsmall))


index100=where(britarray(tsmall) gt 255.)
britarray(index100)=255.

britarray(tbig)=(con2-2.*dvar(tbig))

index101=where(britarray lt 0.)
britarray(index101)=0.

for i=0,iiv-1 do begin
 for j=0,jjv-1 do begin
  if britarray(i,j) lt 175. then temp(i,j)=(660.-britarray(i,j))/2.
  if britarray(i,j) ge 175. then temp(i,j)=418.-britarray(i,j)
 endfor
endfor  
;
; END OF SCALING 
;
;rbp
;dvar=britarray
;
datmax=255.
datmin=0.
;
nlevels=254
datlevel=1.+findgen(nlevels+1)
;btlevel=168.+(330.-168.)*indgen(256)/255.
;btlevel=min(temp)+(max(temp)-min(temp))*indgen(256)/255.
btlevel=fltarr(255)
for i=0,nlevels do begin
 if i lt 175 then btlevel(i)=(660.-datlevel(i))/2.
 if i ge 175 then btlevel(i)=418.-datlevel(i)
endfor

;
; LOGIC FOR DISPLAY BT INSTEAD OF BRIT ON A LEGEND
;
index210=where(btlevel lt 210.5 and btlevel gt 209.5)
index230=where(btlevel lt 230.5 and btlevel gt 229.5)
index250=where(btlevel lt 250.5 and btlevel gt 249.5)
index270=where(btlevel lt 270.5 and btlevel gt 269.5)
index290=where(btlevel lt 290.5 and btlevel gt 289.5)
index310=where(btlevel lt 310.5 and btlevel gt 309.5)
a210=datlevel(index210)
a230=datlevel(index230)
a250=datlevel(index250)
a270=datlevel(index270)
a290=datlevel(index290)
a310=datlevel(index310)

;btlevel=330.-(max(temp)-min(temp))*indgen(256)/255.

openr,10,'/home/mrogal/CRTM/PROXY/ga20p.txt'
rr=intarr(256)
rg=intarr(256)
rb=intarr(256)
data=intarr(3,256)
readf,10,data
rr=data(0,*) & rg=data(1,*) & rb=data(2,*)
rr=reform(rr) & rg=reform(rg) & rb=reform(rb)
close,10

nxpix=1200L
nypix=720L
SETPLOT='Z'
if setplot eq 'Z' then begin
 set_plot,'Z'
 device,set_resolution=[nxpix,nypix],z_buffer=0
 win_nx=!d.x_size
 win_ny=!d.y_size
endif
;
datmax=255.
datmin=0.
;
nlevels=254
datlevel=findgen(nlevels+1)
datcolor=findgen(nlevels+1)
;
RR = BYTSCL(rr)
RG = BYTSCL(rg)
RB = BYTSCL(rb)
TVLCT,rr,rg,rb
  !p.background=255
  !p.color=0
   erase
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
;
  set_viewport,.02,.98,.01,.99
  !p.charsize=2.5
  !psym=0.

    MAP_SET,0,0,0,limit=[18,-133,51.5,-63],/noeras,/contin,color=0, mlinethick=3,/USA
;    contour,dvar,lon,lat,level=datlevel,c_color=datcolor,/cell_fill,/overplot,/noeras,$
    contour,dvar,lon,lat,level=reverse(btlevel),c_color=reverse(datcolor),/cell_fill,/overplot,/noeras,$
            ystyle=1,xstyle=1
    MAP_SET,0,0,0,limit=[18,-133,51.5,-63],/noerase,/contin,color=0, mlinethick=3,/USA

xyouts,[.03],[.05],['!17SSEC/CIMSS'],charsize=1.4,/normal
xyouts,[.03],[.02],['!17CRTM/WRF-CHEM'],charsize=1.4,/normal
xyouts,[.36],[.02],['ABI Band '+band+' '+date+' '+hour+':00 UTC!X'],charsize=1.4,/normal
xyouts,[.87],[.07],['BT(K)'],charsize=1.4,/normal
;colorbar

nametick=['310','290','270','250','230','210']
;nametick=['210','230','250','270','290','310']

tabcolor=reverse(datcolor)
  !p.charsize=1.
        !psym=0
        imax=max(datlevel)
        imin=min(datlevel)
        set_viewport,.92,.96,.05,.5
        !type=2^2+2^3+2^6
        plot,[imax,imin],[0,0],yrange=[imin,imax-1],xrange=[0,10],$
;        ytitle='BT',
        /noeras,ystyle=1,xstyle=4, $
        yticks=5,ytickname=nametick,$
        ytickv=[a310,a290,a270,a250,a230,a210],$
        charsize=1.3 
        xbox=[0,0,0,10,10]
        x2=imax
        for j=0,254 do begin
            dx=-1.
            ybox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=tabcolor(j)
            x2=x2+dx

;          if j lt 175 then begin
;            dx=btlevel(170)-btlevel(169)
;            ybox=[x2,x2,x2+dx,x2+dx,x2]
;            polyfill,xbox,ybox,color=datcolor(j)
;            x2=x2+dx
;          endif
;          if j ge 175 then begin
;            dx=btlevel(200)-btlevel(199)
;            ybox=[x2,x2,x2+dx,x2+dx,x2]
;            polyfill,xbox,ybox,color=datcolor(j)
;           x2=x2+dx
;          endif
        endfor
;
 image=tvrd(0,0,win_nx,win_ny)
 image_byt=bytscl(image,min=0,max=255)
 tvlct,r,g,b,/get
 write_png,'/home/mrogal/CRTM/PROXY/PNG_WEB/SABI_IR_'+date+'_'+hour+'_'+pvar+'.png',image_byt,r,g,b
;
print, date,hour,pvar
device, /close
;
  endfor
;
jump:
endfor ; hr loop
;
end


 
