idir='/data/kbah/output/rgb/daily/
ifile=[$
'2014_05_21_00_green_lux.dat',$
'2014_05_22_00_green_lux.dat',$
'2014_05_23_00_green_lux.dat'$
]
nfiles=n_elements(ifile)

for nf=0,nfiles-1 do begin
	openr,1,idir+ifile(nf),/f77
	dim=lonarr(3)
	readu,1,dim
	nx=dim(0) & ny=dim(1) &	nz=dim(2)
	xvar=fltarr(nx) & yvar=fltarr(ny) & zvar=fltarr(nz)
	
	readu,1,xvar,yvar,zvar
	cube=fltarr(nx,ny,nz)
	readu,1,cube
	close,1
	
	if nf eq 0 then begin
		cube_bar=cube
		cube_count=intarr(nx,ny,nz)
	endif

	if nf gt 0 then cube_bar=cube_bar+cube
		index=where(cube gt 0.) 
	if index(0) ne -1 then cube_count(index)=cube_count(index)+1

	;;
	;; DO NOT PLOT,CUBE!!!!!!!!!! array is too big
	;;
	;cube2d=fltarr(nx,ny)
	;count2d=fltarr(nx,ny)
	;for i=0,nx-1 do begin
	;	for j=0,ny-1 do begin
	;		dum=reform(cube(i,j,*),nz)
	;		index=where(dum ne 0.)
	;		if index(0) ne -1 then begin
	;			bar=total(dum(index))/(1.*n_elements(index))
	;			cube2d(i,j)=bar
	;			count2d(i,j)=n_elements(index)
	;		endif
	;	endfor
	;endfor
	;
	;help,cube2d
	;contour,cube2d,xvar,yvar,level=.02*findgen(31),/cell_fill
endfor

index=where(cube_count ne 0)
cube_bar(index)=cube_bar(index)/(1.*cube_count(index))

cube2d=fltarr(nx,ny)
count2d=fltarr(nx,ny)
for i=0,nx-1 do begin
	for j=0,ny-1 do begin
		dum=reform(cube_bar(i,j,*),nz)
		index=where(dum ne 0.)
		if index(0) ne -1 then begin
			bar=total(dum(index))/(1.*n_elements(index))
			cube2d(i,j)=bar
			count2d(i,j)=n_elements(index)
		endif
	endfor
endfor
contour,cube2d,xvar,yvar,level=.02*findgen(31),/cell_fill

end

