#!/bin/bash


scripts='/home/kbah/code/wrf-chem/scripts'


#make date directory for multi-band-files

in_dir=${in_path}${datedir}
out_dir=${out_path}${datedir}

if [ ! -d ${out_dir} ]; then
 mkdir ${out_dir}
fi


cd ${out_dir}

temp="$(ls *.fil 2>/dev/null)" 
#echo "temp= $temp"

if [ ! -z "$temp" ]; then
  rm *.fil
fi
# ls -l *.fil


# Create a .fil file to be passed in the IDL sub-routine for multibanded files generations.
fil_file=${out_path}/GESNDR.fil
ls ${in_dir}/GESNDR_band01*.nc | wc -l >$fil_file
ls -1 ${in_dir}/GESNDR_band01*.nc | cut -c78-94>>$fil_file

/usr/local/bin/idl < $scripts/call_idl_sub_routines.sh

exit 0
