
FUNCTION READ_VAR, afile, avar
      ncdfid= NCDF_OPEN(afile(0))
      
      fileinfo= NCDF_INQUIRE(ncdfid)
      dname1='west_east' & dname2='south_north' ; & dname3=avar       
      
      WE = NCDF_DIMID( ncdfid, dname1) 
      SE = NCDF_DIMID( ncdfid, dname2)
     ; data=NCDF_DIMID( ncdfid, dname3)
    
      NCDF_DIMINQ, ncdfid, WE, Name1, Size1 
      NCDF_DIMINQ, ncdfid, SE, Name2, Size2
    
      ;var_lats={data:FLTARR(Size1,Size2),units:'', name:''}  
      ;var_lons={data:FLTARR(Size1,Size2),units:'', name:''} 
      var_data={data:FLTARR(Size1,Size2),units:'', name:''}
      var_data.data(*,*)=1.0
   
      ngatts=fileinfo.ngatts
      nvars=fileinfo.nvars
      varnames=STRARR(nvars)
      
      FOR j=0L, nvars -1L DO BEGIN
           varinfo=NCDF_VARINQ(ncdfid,j)
           varnames(j)=varinfo.name  
     ENDFOR
    
     j=WHERE(varnames(*) EQ avar(0))  
     IF (SIZE(j, /N_ELEMENTS) GE 1) THEN BEGIN
             varinfo=NCDF_VARINQ(ncdfid,j(0))
            ;dataset(i).var=varinfo.name            
             varid=NCDF_VARID(ncdfid, varinfo.name)
             NCDF_VARGET,ncdfid, varid, temp_data
             var_data.data = temp_data
              
             pp=NCDF_attname(ncdfid, varid, 0)
             NCDF_ATTGET, ncdfid, varid, pp, attvalue
             var_data.units=string(attvalue); Attribute value
            
             pp=NCDF_attname(ncdfid, varid, 1)
             NCDF_ATTGET, ncdfid, varid, pp, attvalue
             var_data.name=string(attvalue); Attribute value
    ENDIF
index=where(var_data.data gt -999.0)
;print, 'avar=', avar
;print, 'index=', index
IF (N_ELEMENTS(index) LE 1) THEN BEGIN
     ; print,var_data.name,' ',var_data.units,' ',median(var_data.data(index)),n_elements(index)
 ;ENDIF ELSE BEGIN
       print, 'This file:', afile
       print,'with variable: ', avar,' contains only missing values '
;ENDELSE 
ENDIF  

 RETURN,var_data
END
